<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Community Edition 1.0.0 (Release Candidate 2)           |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify it  |
// | under the terms of the GNU General Public License version 3 as published |
// | by the Free Software Foundation.                                         |
// |                                                                          |
// | This program is distributed in the hope that it will be useful, but      |
// | WITHOUT ANY WARRANTY; without even the implied warranty of               |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. For more details    |
// | see the GNU General Public License.                                      |
// |                                                                          |
// | You should have received a copy of the GNU General Public License along  |
// | with this program; if not, see http://www.gnu.org/licenses or write to   |
// | the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,     |
// | Boston, MA 02110-1301 USA.                                               |
// |                                                                          |
// | You can contact Esselbach Internet Solutions at the following address:   |
// | Rautenstrauchgasse 6-16/4, A-1110 Vienna, Austria                        |
// | or via email at office (at) esselbach.com                                |
// |                                                                          |
// | The interactive user interfaces in modified source and object code       |
// | versions of this program must display Appropriate Legal Notices,         |
// | as required under Section 5 of the GNU General Public License version 3. |
// | In accordance with Section 7(b) of the GNU General Public License        |
// | version 3, these Appropriate Legal Notices must retain the display of    |
// | the "Managed with Contentteller" logo and retain the original            |
// | copyright notice.                                                        |
// |                                                                          |
// | If the display of the logos are not reasonably feasible for technical    |
// | reasons, the Appropriate Legal Notices must display the words "Managed   |
// | with Contentteller"                                                      |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+ 
// | Build: 499                                                               |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Files
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function FilesDoSubmitPAD
 * A function to add a PAD to the submission queue
 * @author Philipp Louis Esselbach
 */
function FilesDoSubmitPAD()
{
	global $config, $database, $templates, $system, $preferences, $security, $user, $ipaddr, $input_file_name, $input_file_version, $input_file_size, $input_file_description, $input_file_keywords, $input_file_smalldescription, $input_file_longdescription, $input_file_cost, $input_file_company, $input_file_homepage, $input_file_email, $input_file_language, $input_file_os_list, $input_file_changeinfo, $input_file_agreement, $input_primary_url, $input_secondary_url, $input_order_url, $input_screenshot_url, $input_icon_url; // Cosmin mod
	$input_anon_name = ( isset( $_POST[ 'input_anon_name' ] ) ) ? $security -> checkvar( $_POST[ 'input_anon_name' ] ) : "" ;
	$input_anon_email = ( isset( $_POST[ 'input_anon_email' ] ) ) ? $security -> checkvar( $_POST[ 'input_anon_email' ] ) : "" ;
	$input_securitycode = ( isset( $_POST[ 'input_securitycode' ] ) ) ? $security -> checkvar( $_POST[ 'input_securitycode' ] ) : "" ;
	$input_category = ( isset( $_POST[ 'input_category' ] ) ) ? $security -> checkvar( $_POST[ 'input_category' ] ) : "" ;
	$input_pad = ( isset( $_POST[ 'input_pad' ] ) ) ? $security -> checkvar( $_POST[ 'input_pad' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_block','site_login_anon','site_login_user','site_invalid_form','files_submission_header','files_submission_done','files_submission_footer','files_submission_error_noname','files_submission_error_noemail','files_submission_error_nopad','files_submission_error_padexists','files_submission_error_banned','files_submission_error_userexists','files_submission_error_emailexists','files_error_securitycode','files_submission_email_subject','files_submission_email_body'", $preferences[ 'current_theme' ] );
	$insert = $system -> getinsert( $preferences, $main_templates );
	$insert[ 'page_name' ] = $preferences[ 'website_name' ];
	$insert[ 'page_description' ] = $preferences[ 'website_description' ];
	$insert[ 'page_keywords' ] = $preferences[ 'website_keywords' ];
	session_start();
	
	if( ( $_SESSION[ 'files_security_hash' ] != $input_security_hash ) and( $preferences[ 'website_subsessions_user' ] ) )
	{
		echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
		echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
		echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
		exit;
	}
	
	if( $preferences[ 'files_allow_submissions' ] )
	{
		if( $preferences[ 'files_allow_unregsubmit' ] and !$user[ 'user_status' ] )
		{
			$input_authorid = 0;
			$input_author = $input_anon_name;
			$input_email = $input_anon_email;
			
			if( !$input_anon_name )
			{
				$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_noname_html' ], $main_templates[ 'files_submission_error_noname_php' ], $insert );
			}
			elseif( !$input_anon_email )
			{
				$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_noemail_html' ], $main_templates[ 'files_submission_error_noemail_php' ], $insert );
			}
		}
		
		if( $user[ 'user_status' ] )
		{
			$input_authorid = $database -> dbescape( $user[ 'user_id' ] );
			$input_author = $database -> dbescape( $user[ 'user_name' ] );
			$input_email = $database -> dbescape( $user[ 'user_email' ] );
		}
		
		if( $preferences[ 'files_securitycode' ] and function_exists( "imagestring" ) )
		{
			session_start();
			
			if( $_SESSION[ 'files_security_code' ] != $input_securitycode )
			{
				$error = $templates -> exectemplate( $main_templates[ 'files_error_securitycode_html' ], $main_templates[ 'files_error_securitycode_php' ], $insert );
			}
		}
		
		if( $preferences[ 'files_allow_unregsubmit' ] or $user[ 'user_status' ] )
		{
			if( $user[ 'user_status' ] == 5 )
			{
				$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_banned_html' ], $main_templates[ 'files_submission_error_banned_php' ], $insert );
			}
			elseif( !$input_pad )
			{
				$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_nopad_html' ], $main_templates[ 'files_submission_error_nopad_php' ], $insert );
			}
			
			$query = $database -> dbquery( "SELECT file_id FROM " . DB_PREFIX . "esselbach_ct_files WHERE file_pad = '" . $input_pad . "'" );
			
			if( $database -> dbrows( $query ) )
			{
				$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_padexists_html' ], $main_templates[ 'files_submission_error_padexists_php' ], $insert );
			}
			
			if( !isset( $error ) and !$user[ 'user_status' ] )
			{
				$query = $database -> dbquery( "SELECT user_id FROM " . DB_PREFIX . "esselbach_ct_users WHERE user_name = '" . $input_anon_name . "'" );
				
				if( $database -> dbrows( $query ) )
				{
					$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_userexists_html' ], $main_templates[ 'files_submission_error_userexists_php' ], $insert );
				}
				
				$query = $database -> dbquery( "SELECT user_id FROM " . DB_PREFIX . "esselbach_ct_users WHERE user_email = '" . $input_anon_email . "'" );
				
				if( $database -> dbrows( $query ) )
				{
					$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_emailexists_html' ], $main_templates[ 'files_submission_error_emailexists_php' ], $insert );
				}
			}
		}
		
		if( isset( $error ) )
		{
			FilesSubmitPAD( $error );
		}
		else
		{
			$templates -> initgzip();
			echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
			
			if( $preferences[ 'files_navigation' ] )
			{
				echo $templates -> exectemplate( $main_templates[ 'files_submission_header_html' ], $main_templates[ 'files_submission_header_php' ], $insert );
			}
			
			$input_pad = str_replace( "..", "", $input_pad );
			
			if( function_exists( "curl_init" ) )
			{
				$pad = curl_init( $input_pad );
				
				if( preg_match( "/https/i", $input_pad ) )
				{
					curl_setopt( $pad, CURLOPT_PORT, 443 );
					curl_setopt( $pad, CURLOPT_SSL_VERIFYPEER, false );
				}
				
				curl_setopt( $pad, CURLOPT_RETURNTRANSFER, 1 );
				curl_setopt( $pad, CURLOPT_USERAGENT, "Esselbach Contentteller CMS" );
				$data = curl_exec( $pad );
				curl_close( $pad );
			}
			else
			{
				$pad = @fopen( $input_pad, "r" );
				$data = fread( $pad, 4096 );
				fclose( $pad );
			}
			
			
			if( $data )
			{
				$input_file_name = "";
				$input_file_version = "";
				$input_file_size = "";
				$input_file_description = "";
				$input_file_keywords = "";
				$input_file_smalldescription = "";
				$input_file_longdescription = "";
				$input_file_cost = "";
				$input_file_company = "";
				$input_file_homepage = "";
				$input_file_email = "";
				$input_file_language = "";
				$input_file_os_list = "";
				$input_file_changeinfo = "";
				$input_file_agreement = "";
				$input_primary_url = "";
				$input_secondary_url = "";
				
				// Cosmin mod - Start
				$input_order_url = "";
				$input_screenshot_url = "";
				$input_icon_url = "";
				// Cosmin mid - End
				
				if( $preferences[ 'website_charset' ] == "ISO-8859-1" or $preferences[ 'website_charset' ] == "UTF-8" or $preferences[ 'website_charset' ] == "US-ASCII" )
				{
					$xml = xml_parser_create( $preferences[ 'website_charset' ] );
				}
				else
				{
					$xml = xml_parser_create();
				}
				
				xml_set_element_handler( $xml, "padstart", "padend" );
				xml_set_character_data_handler( $xml, "padparse" );
				xml_parse( $xml, $data );
				xml_parser_free( $xml );
				$input_name = $database -> dbescape( $input_file_name );
				$input_version = $database -> dbescape( $input_file_version );
				$input_size = $database -> dbescape( $input_file_size );
				$input_description = $database -> dbescape( $input_file_description );
				$input_keywords = $database -> dbescape( $input_file_keywords );
				$input_smalldescription = $database -> dbescape( $input_file_smalldescription );
				$input_longdescription = $database -> dbescape( $input_file_description );
				$input_cost = $database -> dbescape( $input_file_cost );
				$input_company = $database -> dbescape( $input_file_company );
				$input_homepage = $database -> dbescape( $input_file_homepage );
				$input_language = $database -> dbescape( $input_file_language );
				$input_os_list = $database -> dbescape( $input_file_os_list );
				$input_changetext = $database -> dbescape( $input_file_changeinfo );
				$input_agreement = $database -> dbescape( $input_file_agreement );
				$input_downloadurl1 = $database -> dbescape( $input_primary_url );
				$input_downloadurl2 = $database -> dbescape( $input_secondary_url );
				$input_smalldescription_parsed = $input_file_smalldescription;
				$input_longdescription_parsed = $input_file_longdescription;
				$input_smalldescription_parsed = $system -> dechomp( $input_smalldescription_parsed );
				$input_longdescription_parsed = $system -> dechomp( $input_longdescription_parsed );
				$input_smalldescription_parsed = $system -> smilies( $input_smalldescription_parsed );
				$input_longdescription_parsed = $system -> smilies( $input_longdescription_parsed );
				$input_smalldescription_parsed = $system -> code( $input_smalldescription_parsed );
				$input_longdescription_parsed = $system -> code( $input_longdescription_parsed );
				$input_smalldescription_parsed = $database -> dbescape( $input_smalldescription_parsed );
				$input_longdescription_parsed = $database -> dbescape( $input_longdescription_parsed );
				
				// Cosmin mod - Start
				$input_fields = base64_encode( $system -> stripthis( $input_order_url ) ) . "|" . base64_encode( $system -> stripthis( $input_screenshot_url ) ) . "|" . base64_encode( $system -> stripthis( $input_icon_url ) ) . "||||||||||||||||||||||" ;
				// Cosmin mod - End
				
				$input_seo = $system -> doseo( $input_file_name );
				$query = $database -> dbquery( "SELECT COUNT(file_id) FROM " . DB_PREFIX . "esselbach_ct_files WHERE file_seo = '" . $input_seo . "'" );
				list( $seo_files ) = $database -> dbrow( $query );
				
				if( $seo_files )
				{
					$input_seo .= "_" . substr( md5( rand( 1, 32768 ) ), 1, 4 );
				}
				
				$ignore_submission = 0;
				
				if( $preferences[ 'files_submissions_ignore' ] )
				{
					$ignored_words = explode( " ", $preferences[ 'fils_submissions_ignore' ] );
					
					for( $i = 0; $i < count( $ignored_words ); $i++ )
					{
						
						if( ( preg_match( "/" . $ignored_words[ $i ] . "/i", $input_file_name ) ) or( preg_match( "/" . $ignored_words[ $i ] . "/i", $input_file_smalldescription ) ) or( preg_match( "/" . $ignored_words[ $i ] . "/i", $input_file_longdescription ) ) )
						{
							$ignore_submission = 1;
						}
					}
				}
				
				if( !$ignore_submission )
				{
					if( $preferences[ 'files_submissions_email' ] )
					{
						$query = $database -> dbquery( "SELECT u.user_name, u.user_email FROM " . DB_PREFIX . "esselbach_ct_users u, " . DB_PREFIX . "esselbach_ct_permissions p WHERE p.permission_admin = u.user_loginname AND p.permission_module = 'files' AND p.permission_setting = '1' AND u.user_status = '2'" );
						
						while( list( $user_name, $user_email ) = $database -> dbrow( $query ) )
						{
							$insert[ 'filequeue_name' ] = $input_file_name;
							$insert[ 'filequeue_version' ] = $input_file_version;
							$insert[ 'filequeue_author' ] = $input_author;
							$insert[ 'filequeue_smalldescription' ] = $input_file_smalldescription;
							$email_subject = $templates -> exectemplate( $main_templates[ 'files_submission_email_subject_html' ], $main_templates[ 'files_submission_email_subject_php' ], $insert );
							$email_body = $templates -> exectemplate( $main_templates[ 'files_submission_email_body_html' ], $main_templates[ 'files_submission_email_welcomebody_php' ], $insert );
							$email_header = $system -> mailheader( $preferences[ 'user_registration_adminname' ], $preferences[ 'user_registration_adminemail' ], $user_name, $user_email );
							
							if( $preferences[ 'user_registration_emailserver' ] == "SMTP" )
							{
								$error = $system -> smtpmail( $preferences[ 'user_registration_smtphost' ], $preferences[ 'user_registration_smtpport' ], $preferences[ 'user_registration_smtpusername' ], $preferences[ 'user_registration_smtppassword' ], $preferences[ 'user_registration_adminemail' ], $user_email, $email_subject, $email_body, $email_header );
							}
							else
							{
								mail( $user_email, $email_subject, $email_body, $email_header );
							}
						}
					}
					
					$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesqueue (filequeue_id, filequeue_authorid, filequeue_author, filequeue_email, filequeue_status, filequeue_website, filequeue_category, filequeue_name, filequeue_version, filequeue_pad, filequeue_smalldescription, filequeue_longdescription, filequeue_size, filequeue_cost, filequeue_company, filequeue_homepage, filequeue_companyemail, filequeue_language, filequeue_os, filequeue_changeinfo, filequeue_agreement, filequeue_downloadurl1, filequeue_downloadurl2, filequeue_fields, filequeue_postip, filequeue_editip, filequeue_editadmin) VALUES (NULL, '" . $input_authorid . "', '" . $input_author . "', '" . $input_email . "', '0', '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $input_category . "', '" . $input_name . "', '" . $input_version . "', '" . $input_pad . "', '" . $input_smalldescription . "', '" . $input_longdescription . "', '" . $input_size . "', '" . $input_cost . "', '" . $input_company . "', '" . $input_homepage . "', '" . $input_email . "', '1', '" . $input_os_list . "', '" . $input_changetext . "', '" . $input_agreement . "', '" . $input_downloadurl1 . "', '" . $input_downloadurl2 . "', '". $input_fields . "', '" . $ipaddr . "', '" . $ipaddr . "', '')" ); // Cosmin mod
				}
				
				echo $templates -> exectemplate( $main_templates[ 'files_submission_done_html' ], $main_templates[ 'files_submission_done_php' ], $insert );
			}
			else
			{
				echo $templates -> exectemplate( $main_templates[ 'files_submission_error_nopad_html' ], $main_templates[ 'files_submission_error_nopad_php' ], $insert );
			}
			
			if( $preferences[ 'files_navigation' ] )
			{
				echo $templates -> exectemplate( $main_templates[ 'files_submission_footer_html' ], $main_templates[ 'files_submission_footer_php' ], $insert );
			}
			
			echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
		}
	}
}

function padstart( $parser, $name, $attrs )
{
	global $diz, $tag;
	
	if( $diz )
	{
		$tag = $name;
	}
	
	
	if( $name == "XML_DIZ_INFO" )
	{
		$diz = 1;
	}
}

function padparse( $parser, $data )
{
	global $diz, $tag, $input_file_name, $input_file_version, $input_file_size, $input_file_description, $input_file_keywords, $input_file_smalldescription, $input_file_longdescription, $input_file_cost, $input_file_company, $input_file_homepage, $input_file_email, $input_file_language, $input_file_os_list, $input_file_changeinfo, $input_file_agreement, $input_primary_url, $input_secondary_url, $input_order_url, $input_screenshot_url, $input_icon_url; // Cosmin mod

	//echo htmlspecialchars($tag)."<br />";
	if( $diz )
	{
		
		if( $tag == "PROGRAM_NAME" )
		{
			$input_file_name .= $data;
		}
		elseif( $tag == "PROGRAM_VERSION" )
		{
			$input_file_version .= $data;
		}
		elseif( $tag == "FILE_SIZE_MB" )
		{
			$input_file_size .= $data;
		}
		elseif( $tag == "CHAR_DESC_80" )
		{
			$input_file_description .= $data;
		}
		elseif( $tag == "KEYWORDS" )
		{
			$input_file_keywords .= $data;
		}
		elseif( $tag == "CHAR_DESC_250" )
		{
			$input_file_smalldescription .= $data;
		}
		elseif( $tag == "CHAR_DESC_2000" )
		{
			$input_file_longdescription .= $data;
		}
		elseif( $tag == "PROGRAM_COST_DOLLARS" )
		{
			$input_file_cost .= $data;
		}
		elseif( $tag == "COMPANY_NAME" )
		{
			$input_file_company .= $data;
		}
		elseif( $tag == "COMPANY_WEBSITE_URL" )
		{
			$input_file_homepage .= $data;
		}
		elseif( $tag == "GENERAL_EMAIL" )
		{
			$input_file_email .= $data;
		}
		elseif( $tag == "PROGRAMM_LANGUAGE" )
		{
			$input_file_language .= $data;
		}
		elseif( $tag == "PROGRAM_OS_SUPPORT" )
		{
			$input_file_os_list .= $data;
		}
		elseif( $tag == "PROGRAM_CHANGE_INFO" )
		{
			$input_file_changeinfo .= $data;
		}
		elseif( $tag == "EULA" )
		{
			$input_file_agreement .= $data;
		}
		elseif( $tag == "PRIMARY_DOWNLOAD_URL" )
		{
			$input_primary_url .= $data;
		}
		elseif( $tag == "SECONDARY_DOWNLOAD_URL" )
		{
			$input_secondary_url .= $data;
		}
		elseif( $tag == "APPLICATION_ORDER_URL") // Cosmin mod - Start
		{
			$input_order_url .= $data;
		}
		elseif( $tag == "APPLICATION_SCREENSHOT_URL")
		{
			$input_screenshot_url .= $data;
		}
		elseif( $tag == "APPLICATION_ICON_URL") 
		{
			$input_icon_url .= $data;
		} // Cosmin mod - End
	}
}

function padend( $parser, $name )
{
	global $diz, $input_file_name, $input_file_version, $input_file_size, $input_file_description, $input_file_keywords, $input_file_smalldescription, $input_file_longdescription, $input_file_cost, $input_file_company, $input_file_homepage, $input_file_email, $input_file_language, $input_file_os_list, $input_file_changeinfo, $input_file_agreement, $input_primary_url, $input_secondary_url, $input_order_url, $input_screenshot_url, $input_icon_url; // Cosmin mod
	
	if( $name == "XML_DIZ_INFO" )
	{
		$input_file_name = rtrim( ltrim( $input_file_name ) );
		$input_file_version = rtrim( ltrim( $input_file_version ) );
		$input_file_size = rtrim( ltrim( $input_file_size ) ) . "MB";
		$input_file_description = str_replace( "\t", "", rtrim( ltrim( $input_file_description ) ) );
		$input_file_keywords = str_replace( "\t", "", rtrim( ltrim( $input_file_keywords ) ) );
		$input_file_smalldescription = str_replace( "\t", "", rtrim( ltrim( $input_file_smalldescription ) ) );
		$input_file_longdescription = str_replace( "\t", "", rtrim( ltrim( $input_file_longdescription ) ) );
		$input_file_cost = "USD " . rtrim( ltrim( $input_file_cost ) );
		$input_file_company = rtrim( ltrim( $input_file_company ) );
		$input_file_homepage = rtrim( ltrim( $input_file_homepage ) );
		$input_file_email = rtrim( ltrim( $input_file_email ) );
		$input_file_language = rtrim( ltrim( $input_file_language ) );
		$input_file_os_list = rtrim( ltrim( $input_file_os_list ) );
		$input_file_changeinfo = str_replace( "\t", "", rtrim( ltrim( $input_file_changeinfo ) ) );
		$input_file_agreement = str_replace( "\t", "", rtrim( ltrim( $input_file_agreement ) ) );
		$input_primary_url = rtrim( ltrim( $input_primary_url ) );
		$input_secondary_url = rtrim( ltrim( $input_secondary_url ) );
		
		// Cosmin mod - Start
		$input_screenshot_url = rtrim( ltrim( $input_screenshot_url ) );		
		$input_icon_url = rtrim( ltrim( $input_icon_url ) );		
		$input_order_url = rtrim( ltrim( $input_order_url ) );		
		// Cosmin mod - End
		
		if( $input_primary_url == $input_secondary_url )
		{
			$input_secondary_url = "";
		}
		
		$diz = 0;
	}
}
?>